Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -5712,23 +5949,23 @@
        INTEGER(iwp) ::  tn = 0    !< number of OpenMP thread
        
-       REAL(wp)    ::  ibit27 !< flag indicating 1st-order scheme along x-direction
-       REAL(wp)    ::  ibit28 !< flag indicating 3rd-order scheme along x-direction
-       REAL(wp)    ::  ibit29 !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit18 !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit19 !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit20 !< flag indicating 5th-order scheme along x-direction
 #ifdef _OPENACC
-       REAL(wp)    ::  ibit27_l !< flag indicating 1st-order scheme along x-direction
-       REAL(wp)    ::  ibit28_l !< flag indicating 3rd-order scheme along x-direction
-       REAL(wp)    ::  ibit29_l !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit18_l !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit19_l !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit20_l !< flag indicating 5th-order scheme along x-direction
 #endif
-       REAL(wp)    ::  ibit30 !< flag indicating 1st-order scheme along y-direction
-       REAL(wp)    ::  ibit31 !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp)    ::  ibit32 !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit21 !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit22 !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit23 !< flag indicating 5th-order scheme along y-direction
 #ifdef _OPENACC
-       REAL(wp)    ::  ibit30_s !< flag indicating 1st-order scheme along y-direction
-       REAL(wp)    ::  ibit31_s !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp)    ::  ibit32_s !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit21_s !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit22_s !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit23_s !< flag indicating 5th-order scheme along y-direction
 #endif
-       REAL(wp)    ::  ibit33 !< flag indicating 1st-order scheme along z-direction
-       REAL(wp)    ::  ibit34 !< flag indicating 3rd-order scheme along z-direction
-       REAL(wp)    ::  ibit35 !< flag indicating 5th-order scheme along z-direction
+       REAL(wp)    ::  ibit24 !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit25 !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit26 !< flag indicating 5th-order scheme along z-direction
        REAL(wp)    ::  diss_d !< artificial dissipation term at grid box bottom
        REAL(wp)    ::  div    !< divergence on w-grid
@@ -5792,20 +6029,20 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit29 = REAL( IBITS(advc_flags_1(k,j,i-1),29,1), KIND = wp )
-             ibit28 = REAL( IBITS(advc_flags_1(k,j,i-1),28,1), KIND = wp )
-             ibit27 = REAL( IBITS(advc_flags_1(k,j,i-1),27,1), KIND = wp )
+             ibit20 = REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp )
+             ibit19 = REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp )
+             ibit18 = REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )
 
              u_comp                   = u(k+1,j,i) + u(k,j,i) - gu
              swap_flux_x_local_w(k,j) = u_comp * (                             &
-                                      ( 37.0_wp * ibit29 * adv_mom_5              &
-                                   +     7.0_wp * ibit28 * adv_mom_3              &
-                                   +              ibit27 * adv_mom_1              &
+                                      ( 37.0_wp * ibit20 * adv_mom_5              &
+                                   +     7.0_wp * ibit19 * adv_mom_3              &
+                                   +              ibit18 * adv_mom_1              &
                                       ) *                                      &
                                      ( w(k,j,i)   + w(k,j,i-1) )               &
-                               -      (  8.0_wp * ibit29 * adv_mom_5              &
-                                   +              ibit28 * adv_mom_3              &
+                               -      (  8.0_wp * ibit20 * adv_mom_5              &
+                                   +              ibit19 * adv_mom_3              &
                                       ) *                                      &
                                      ( w(k,j,i+1) + w(k,j,i-2) )               &
-                               +      (           ibit29 * adv_mom_5              &
+                               +      (           ibit20 * adv_mom_5              &
                                       ) *                                      &
                                      ( w(k,j,i+2) + w(k,j,i-3) )               &
@@ -5813,14 +6050,14 @@
 
                swap_diss_x_local_w(k,j) = - ABS( u_comp ) * (                  &
-                                        ( 10.0_wp * ibit29 * adv_mom_5            &
-                                     +     3.0_wp * ibit28 * adv_mom_3            &
-                                     +              ibit27 * adv_mom_1            &
+                                        ( 10.0_wp * ibit20 * adv_mom_5            &
+                                     +     3.0_wp * ibit19 * adv_mom_3            &
+                                     +              ibit18 * adv_mom_1            &
                                         ) *                                    &
                                      ( w(k,j,i)   - w(k,j,i-1) )               &
-                                 -      (  5.0_wp * ibit29 * adv_mom_5            &
-                                     +              ibit28 * adv_mom_3            &
+                                 -      (  5.0_wp * ibit20 * adv_mom_5            &
+                                     +              ibit19 * adv_mom_3            &
                                         ) *                                    &
                                      ( w(k,j,i+1) - w(k,j,i-2) )               &
-                                 +      (           ibit29 * adv_mom_5            &
+                                 +      (           ibit20 * adv_mom_5            &
                                         ) *                                    &
                                      ( w(k,j,i+2) - w(k,j,i-3) )               &
@@ -5848,13 +6085,13 @@
        !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
        !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
-       !$ACC PRIVATE(ibit27, ibit28, ibit29, ibit30, ibit31, ibit32) &
-       !$ACC PRIVATE(ibit27_l, ibit28_l, ibit29_l) &
-       !$ACC PRIVATE(ibit30_s, ibit31_s, ibit32_s) &
-       !$ACC PRIVATE(ibit33, ibit34, ibit35) &
+       !$ACC PRIVATE(ibit18, ibit19, ibit20, ibit21, ibit22, ibit23) &
+       !$ACC PRIVATE(ibit18_l, ibit19_l, ibit20_l) &
+       !$ACC PRIVATE(ibit21_s, ibit22_s, ibit23_s) &
+       !$ACC PRIVATE(ibit24, ibit25, ibit26) &
        !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
        !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
        !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
        !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
-       !$ACC PRESENT(advc_flags_1, advc_flags_2) &
+       !$ACC PRESENT(advc_flags_m) &
        !$ACC PRESENT(u, v, w) &
        !$ACC PRESENT(rho_air, drho_air_zw, ddzu) &
@@ -5869,20 +6106,20 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit32 = REAL( IBITS(advc_flags_2(k,j-1,i),0,1),  KIND = wp )
-             ibit31 = REAL( IBITS(advc_flags_1(k,j-1,i),31,1), KIND = wp )
-             ibit30 = REAL( IBITS(advc_flags_1(k,j-1,i),30,1), KIND = wp )
+             ibit23 = REAL( IBITS(advc_flags_m(k,j-1,i),23,1),  KIND = wp )
+             ibit22 = REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp )
+             ibit21 = REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )
 
              v_comp                 = v(k+1,j,i) + v(k,j,i) - gv
              swap_flux_y_local_w(k) = v_comp * (                              &
-                                    ( 37.0_wp * ibit32 * adv_mom_5               &
-                                 +     7.0_wp * ibit31 * adv_mom_3               &
-                                 +              ibit30 * adv_mom_1               &
+                                    ( 37.0_wp * ibit23 * adv_mom_5               &
+                                 +     7.0_wp * ibit22 * adv_mom_3               &
+                                 +              ibit21 * adv_mom_1               &
                                     ) *                                        &
                                      ( w(k,j,i)   + w(k,j-1,i) )              &
-                             -      (  8.0_wp * ibit32 * adv_mom_5               &
-                                 +              ibit31 * adv_mom_3               &
+                             -      (  8.0_wp * ibit23 * adv_mom_5               &
+                                 +              ibit22 * adv_mom_3               &
                                     ) *                                       &
                                      ( w(k,j+1,i) + w(k,j-2,i) )              &
-                             +      (           ibit32 * adv_mom_5               &
+                             +      (           ibit23 * adv_mom_5               &
                                     ) *                                       &
                                      ( w(k,j+2,i) + w(k,j-3,i) )              &
@@ -5890,14 +6127,14 @@
 
              swap_diss_y_local_w(k) = - ABS( v_comp ) * (                     &
-                                    ( 10.0_wp * ibit32 * adv_mom_5               &
-                                 +     3.0_wp * ibit31 * adv_mom_3               &
-                                 +              ibit30 * adv_mom_1               &
+                                    ( 10.0_wp * ibit23 * adv_mom_5               &
+                                 +     3.0_wp * ibit22 * adv_mom_3               &
+                                 +              ibit21 * adv_mom_1               &
                                     ) *                                       &
                                      ( w(k,j,i)   - w(k,j-1,i) )              &
-                             -      (  5.0_wp * ibit32 * adv_mom_5               &
-                                 +              ibit31 * adv_mom_3               &
+                             -      (  5.0_wp * ibit23 * adv_mom_5               &
+                                 +              ibit22 * adv_mom_3               &
                                     ) *                                       &
                                      ( w(k,j+1,i) - w(k,j-2,i) )              &
-                             +      (           ibit32 * adv_mom_5               &
+                             +      (           ibit23 * adv_mom_5               &
                                     ) *                                       &
                                      ( w(k,j+2,i) - w(k,j-3,i) )              &
@@ -5926,5 +6163,5 @@
 !--          The lower flux has to be calculated explicetely for the tendency
 !--          at the first w-level. For topography wall this is done implicitely
-!--          by advc_flags_1.
+!--          by advc_flags_m.
              k      = nzb + 1
              w_comp = w(k,j,i) + w(k-1,j,i)
@@ -5934,20 +6171,20 @@
              DO  k = nzb+1, nzb_max_l
 
-                ibit29 = REAL( IBITS(advc_flags_1(k,j,i),29,1), KIND = wp )
-                ibit28 = REAL( IBITS(advc_flags_1(k,j,i),28,1), KIND = wp )
-                ibit27 = REAL( IBITS(advc_flags_1(k,j,i),27,1), KIND = wp )
+                ibit20 = REAL( IBITS(advc_flags_m(k,j,i),20,1), KIND = wp )
+                ibit19 = REAL( IBITS(advc_flags_m(k,j,i),19,1), KIND = wp )
+                ibit18 = REAL( IBITS(advc_flags_m(k,j,i),18,1), KIND = wp )
 
                 u_comp = u(k+1,j,i+1) + u(k,j,i+1) - gu
                 flux_r = u_comp * (                                          &
-                          ( 37.0_wp * ibit29 * adv_mom_5                        &
-                       +     7.0_wp * ibit28 * adv_mom_3                        &
-                       +              ibit27 * adv_mom_1                        &
+                          ( 37.0_wp * ibit20 * adv_mom_5                        &
+                       +     7.0_wp * ibit19 * adv_mom_3                        &
+                       +              ibit18 * adv_mom_1                        &
                           ) *                                                &
                                  ( w(k,j,i+1) + w(k,j,i)   )                 &
-                   -      (  8.0_wp * ibit29 * adv_mom_5                        &
-                       +              ibit28 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit20 * adv_mom_5                        &
+                       +              ibit19 * adv_mom_3                        &
                           ) *                                                &
                                  ( w(k,j,i+2) + w(k,j,i-1) )                 &
-                   +      (           ibit29 * adv_mom_5                        &
+                   +      (           ibit20 * adv_mom_5                        &
                           ) *                                                &
                                  ( w(k,j,i+3) + w(k,j,i-2) )                 &
@@ -5955,14 +6192,14 @@
 
                 diss_r = - ABS( u_comp ) * (                                 &
-                          ( 10.0_wp * ibit29 * adv_mom_5                        &
-                       +     3.0_wp * ibit28 * adv_mom_3                        &
-                       +              ibit27 * adv_mom_1                        &
+                          ( 10.0_wp * ibit20 * adv_mom_5                        &
+                       +     3.0_wp * ibit19 * adv_mom_3                        &
+                       +              ibit18 * adv_mom_1                        &
                           ) *                                                &
                                  ( w(k,j,i+1) - w(k,j,i)  )                  &
-                   -      (  5.0_wp * ibit29 * adv_mom_5                        &
-                       +              ibit28 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit20 * adv_mom_5                        &
+                       +              ibit19 * adv_mom_3                        &
                           ) *                                                &
                                  ( w(k,j,i+2) - w(k,j,i-1) )                 &
-                   +      (           ibit29 * adv_mom_5                        &
+                   +      (           ibit20 * adv_mom_5                        &
                           ) *                                                &
                                  ( w(k,j,i+3) - w(k,j,i-2) )                 &
@@ -5972,20 +6209,20 @@
 !
 !--             Recompute the left fluxes.
-                ibit29_l = REAL( IBITS(advc_flags_1(k,j,i-1),29,1), KIND = wp )
-                ibit28_l = REAL( IBITS(advc_flags_1(k,j,i-1),28,1), KIND = wp )
-                ibit27_l = REAL( IBITS(advc_flags_1(k,j,i-1),27,1), KIND = wp )
+                ibit20_l = REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp )
+                ibit19_l = REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp )
+                ibit18_l = REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )
 
                 u_comp_l = u(k+1,j,i) + u(k,j,i) - gu
                 flux_l   = u_comp_l * (                                      &
-                                      ( 37.0_wp * ibit29_l * adv_mom_5          &
-                                   +     7.0_wp * ibit28_l * adv_mom_3          &
-                                   +              ibit27_l * adv_mom_1          &
+                                      ( 37.0_wp * ibit20_l * adv_mom_5          &
+                                   +     7.0_wp * ibit19_l * adv_mom_3          &
+                                   +              ibit18_l * adv_mom_1          &
                                       ) *                                    &
                                      ( w(k,j,i)   + w(k,j,i-1) )             &
-                               -      (  8.0_wp * ibit29_l * adv_mom_5          &
-                                   +              ibit28_l * adv_mom_3          &
+                               -      (  8.0_wp * ibit20_l * adv_mom_5          &
+                                   +              ibit19_l * adv_mom_3          &
                                       ) *                                    &
                                      ( w(k,j,i+1) + w(k,j,i-2) )             &
-                               +      (           ibit29_l * adv_mom_5          &
+                               +      (           ibit20_l * adv_mom_5          &
                                       ) *                                    &
                                      ( w(k,j,i+2) + w(k,j,i-3) )             &
@@ -5993,14 +6230,14 @@
 
                 diss_l   = - ABS( u_comp_l ) * (                             &
-                                        ( 10.0_wp * ibit29_l * adv_mom_5        &
-                                     +     3.0_wp * ibit28_l * adv_mom_3        &
-                                     +              ibit27_l * adv_mom_1        &
+                                        ( 10.0_wp * ibit20_l * adv_mom_5        &
+                                     +     3.0_wp * ibit19_l * adv_mom_3        &
+                                     +              ibit18_l * adv_mom_1        &
                                         ) *                                  &
                                      ( w(k,j,i)   - w(k,j,i-1) )             &
-                                 -      (  5.0_wp * ibit29_l * adv_mom_5        &
-                                     +              ibit28_l * adv_mom_3        &
+                                 -      (  5.0_wp * ibit20_l * adv_mom_5        &
+                                     +              ibit19_l * adv_mom_3        &
                                         ) *                                  &
                                      ( w(k,j,i+1) - w(k,j,i-2) )             &
-                                 +      (           ibit29_l * adv_mom_5        &
+                                 +      (           ibit20_l * adv_mom_5        &
                                         ) *                                  &
                                      ( w(k,j,i+2) - w(k,j,i-3) )             &
@@ -6012,20 +6249,20 @@
 
 
-                ibit32 = REAL( IBITS(advc_flags_2(k,j,i),0,1),  KIND = wp )
-                ibit31 = REAL( IBITS(advc_flags_1(k,j,i),31,1), KIND = wp )
-                ibit30 = REAL( IBITS(advc_flags_1(k,j,i),30,1), KIND = wp )
+                ibit23 = REAL( IBITS(advc_flags_m(k,j,i),23,1), KIND = wp )
+                ibit22 = REAL( IBITS(advc_flags_m(k,j,i),22,1), KIND = wp )
+                ibit21 = REAL( IBITS(advc_flags_m(k,j,i),21,1), KIND = wp )
 
                 v_comp = v(k+1,j+1,i) + v(k,j+1,i) - gv
                 flux_n = v_comp * (                                          &
-                          ( 37.0_wp * ibit32 * adv_mom_5                        &
-                       +     7.0_wp * ibit31 * adv_mom_3                        &
-                       +              ibit30 * adv_mom_1                        &
+                          ( 37.0_wp * ibit23 * adv_mom_5                        &
+                       +     7.0_wp * ibit22 * adv_mom_3                        &
+                       +              ibit21 * adv_mom_1                        &
                           ) *                                                &
                                  ( w(k,j+1,i) + w(k,j,i)   )                 &
-                   -      (  8.0_wp * ibit32 * adv_mom_5                        &
-                       +              ibit31 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit23 * adv_mom_5                        &
+                       +              ibit22 * adv_mom_3                        &
                           ) *                                                 &
                                  ( w(k,j+2,i) + w(k,j-1,i) )                 &
-                   +      (           ibit32 * adv_mom_5                        &
+                   +      (           ibit23 * adv_mom_5                        &
                           ) *                                                &
                                  ( w(k,j+3,i) + w(k,j-2,i) )                 &
@@ -6033,14 +6270,14 @@
 
                 diss_n = - ABS( v_comp ) * (                                 &
-                          ( 10.0_wp * ibit32 * adv_mom_5                        &
-                       +     3.0_wp * ibit31 * adv_mom_3                        &
-                       +              ibit30 * adv_mom_1                        &
+                          ( 10.0_wp * ibit23 * adv_mom_5                        &
+                       +     3.0_wp * ibit22 * adv_mom_3                        &
+                       +              ibit21 * adv_mom_1                        &
                           ) *                                                &
                                  ( w(k,j+1,i) - w(k,j,i)  )                  &
-                   -      (  5.0_wp * ibit32 * adv_mom_5                        &
-                       +              ibit31 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit23 * adv_mom_5                        &
+                       +              ibit22 * adv_mom_3                        &
                           ) *                                                &
                                  ( w(k,j+2,i) - w(k,j-1,i) )                 &
-                   +      (           ibit32 * adv_mom_5                        &
+                   +      (           ibit23 * adv_mom_5                        &
                           ) *                                                &
                                  ( w(k,j+3,i) - w(k,j-2,i) )                 &
@@ -6050,20 +6287,20 @@
 !
 !--             Recompute the south fluxes.
-                ibit32_s = REAL( IBITS(advc_flags_2(k,j-1,i),0,1),  KIND = wp )
-                ibit31_s = REAL( IBITS(advc_flags_1(k,j-1,i),31,1), KIND = wp )
-                ibit30_s = REAL( IBITS(advc_flags_1(k,j-1,i),30,1), KIND = wp )
+                ibit23_s = REAL( IBITS(advc_flags_m(k,j-1,i),23,1), KIND = wp )
+                ibit22_s = REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp )
+                ibit21_s = REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )
 
                 v_comp_s = v(k+1,j,i) + v(k,j,i) - gv
                 flux_s   = v_comp_s * (                                      &
-                                    ( 37.0_wp * ibit32_s * adv_mom_5            &
-                                 +     7.0_wp * ibit31_s * adv_mom_3            &
-                                 +              ibit30_s * adv_mom_1            &
+                                    ( 37.0_wp * ibit23_s * adv_mom_5            &
+                                 +     7.0_wp * ibit22_s * adv_mom_3            &
+                                 +              ibit21_s * adv_mom_1            &
                                     ) *                                      &
                                      ( w(k,j,i)   + w(k,j-1,i) )             &
-                             -      (  8.0_wp * ibit32_s * adv_mom_5            &
-                                 +              ibit31_s * adv_mom_3            &
+                             -      (  8.0_wp * ibit23_s * adv_mom_5            &
+                                 +              ibit22_s * adv_mom_3            &
                                     ) *                                      &
                                      ( w(k,j+1,i) + w(k,j-2,i) )             &
-                             +      (           ibit32_s * adv_mom_5            &
+                             +      (           ibit23_s * adv_mom_5            &
                                     ) *                                      &
                                      ( w(k,j+2,i) + w(k,j-3,i) )             &
@@ -6071,14 +6308,14 @@
 
                 diss_s   = - ABS( v_comp_s ) * (                             &
-                                    ( 10.0_wp * ibit32_s * adv_mom_5            &
-                                 +     3.0_wp * ibit31_s * adv_mom_3            &
-                                 +              ibit30_s * adv_mom_1            &
+                                    ( 10.0_wp * ibit23_s * adv_mom_5            &
+                                 +     3.0_wp * ibit22_s * adv_mom_3            &
+                                 +              ibit21_s * adv_mom_1            &
                                     ) *                                      &
                                      ( w(k,j,i)   - w(k,j-1,i) )             &
-                             -      (  5.0_wp * ibit32_s * adv_mom_5            &
-                                 +              ibit31_s * adv_mom_3            &
+                             -      (  5.0_wp * ibit23_s * adv_mom_5            &
+                                 +              ibit22_s * adv_mom_3            &
                                     ) *                                      &
                                      ( w(k,j+1,i) - w(k,j-2,i) )             &
-                             +      (           ibit32_s * adv_mom_5            &
+                             +      (           ibit23_s * adv_mom_5            &
                                     ) *                                      &
                                      ( w(k,j+2,i) - w(k,j-3,i) )             &
@@ -6092,24 +6329,24 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
-                ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
-                ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
-
-                k_ppp = k + 3 * ibit35
-                k_pp  = k + 2 * ( 1 - ibit33  )
-                k_mm  = k - 2 * ibit35
+                ibit26 = REAL( IBITS(advc_flags_m(k,j,i),26,1), KIND = wp )
+                ibit25 = REAL( IBITS(advc_flags_m(k,j,i),25,1), KIND = wp )
+                ibit24 = REAL( IBITS(advc_flags_m(k,j,i),24,1), KIND = wp )
+
+                k_ppp = k + 3 * ibit26
+                k_pp  = k + 2 * ( 1 - ibit24  )
+                k_mm  = k - 2 * ibit26
 
                 w_comp = w(k+1,j,i) + w(k,j,i)
                 flux_t = w_comp * rho_air(k+1) * (                           &
-                          ( 37.0_wp * ibit35 * adv_mom_5                        &
-                       +     7.0_wp * ibit34 * adv_mom_3                        &
-                       +              ibit33 * adv_mom_1                        &
+                          ( 37.0_wp * ibit26 * adv_mom_5                        &
+                       +     7.0_wp * ibit25 * adv_mom_3                        &
+                       +              ibit24 * adv_mom_1                        &
                           ) *                                                &
                              ( w(k+1,j,i)  + w(k,j,i)     )                  &
-                   -      (  8.0_wp * ibit35 * adv_mom_5                        &
-                       +              ibit34 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit26 * adv_mom_5                        &
+                       +              ibit25 * adv_mom_3                        &
                           ) *                                                &
                              ( w(k_pp,j,i)  + w(k-1,j,i)  )                  &
-                   +      (           ibit35 * adv_mom_5                        &
+                   +      (           ibit26 * adv_mom_5                        &
                           ) *                                                &
                              ( w(k_ppp,j,i) + w(k_mm,j,i) )                  &
@@ -6117,14 +6354,14 @@
 
                 diss_t = - ABS( w_comp ) * rho_air(k+1) * (                  &
-                          ( 10.0_wp * ibit35 * adv_mom_5                        &
-                       +     3.0_wp * ibit34 * adv_mom_3                        &
-                       +              ibit33 * adv_mom_1                        &
+                          ( 10.0_wp * ibit26 * adv_mom_5                        &
+                       +     3.0_wp * ibit25 * adv_mom_3                        &
+                       +              ibit24 * adv_mom_1                        &
                           ) *                                                &
                              ( w(k+1,j,i)   - w(k,j,i)    )                  &
-                   -      (  5.0_wp * ibit35 * adv_mom_5                        &
-                       +              ibit34 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit26 * adv_mom_5                        &
+                       +              ibit25 * adv_mom_3                        &
                           ) *                                                &
                              ( w(k_pp,j,i)  - w(k-1,j,i)  )                  &
-                   +      (           ibit35 * adv_mom_5                        &
+                   +      (           ibit26 * adv_mom_5                        &
                           ) *                                                &
                              ( w(k_ppp,j,i) - w(k_mm,j,i) )                  &
